<?php

   include "../include/include.inc.php";

   // Eerst de categorieen met de forums selecteren
   $s_info = $sql->query("SELECT
                          c.titel AS cat_titel, c.id AS cat_id,
                          f.titel AS forum_titel, f.id AS forum_id, f.beschrijving AS forum_beschrijving,
                          f.topics AS forum_topics, f.berichten AS forum_berichten, f.moderators AS forum_moderators,
                          f.laatste_post AS forum_laatste_post
                          FROM
                          forums_categorieen AS c
                          LEFT JOIN forums_forums AS f ON f.cat = c.id
                          ORDER BY c.ordening ASC, f.ordening");

   // De vorige categorie defineren
   $prev_cat = "";
   
   // De header openen
   $tpl->get_template("header");
   $tpl->assign("titel", "Forums");

   if(!$sql->num_rows($s_info))
   {
      $tpl->get_template("tabel_header,forums_geen,tabel_footer");
      $tpl->assign("tabel_header.titel", "Forums &rsaquo; Geen forums gedefineerd");
   }

   while($f_info = $sql->fetch($s_info))
   {
      // Als de vorige categorie niet dezelfde is als de huidige een nieuwe tabel openen...
      if($prev_cat != $f_info["cat_titel"])
      {
         // Eerst de oude categorie afsluiten (als het niet de eerste tenminste
         if(!empty($prev_cat))
            $tpl->get_template("forums_categorie_footer,tabel_footer");

         // Nu de nieuwe categorie openen
         $tpl->get_template("tabel_header");

         $tpl->assign(array("titel" => $f_info["cat_titel"],
                            "id"    => $f_info["cat_id"]   ,
                           ));

         $tpl->get_template("forums_categorie_header");
      }

      $prev_cat = $f_info["cat_titel"];

      if(!empty($f_info["forum_titel"]))
      {
         // Forum weergeven
         $tpl->get_template("forums_forum");

         // Forum icon & laatste post
         if(!empty($f_info["forum_laatste_post"]))
         {
            @list($laatste_tijd, $laatste_topic_id, $laatste_auteur, $laatste_auteur_id) = @explode(",", $f_info["forum_laatste_post"]);
            
            $forum_icon = forum_actief($laatste_tijd);
            $laatste_post = "door <b><a href=\"" . url . "leden/profiel/" . $laatste_auteur_id . "\" class=\"zwart\">" . $laatste_auteur . "</a></b> op " . date_format($laatste_tijd) . " om " . date("H:i", $laatste_tijd) . " <b><a href=\"" . url . "forums/topic/" . $laatste_topic_id . "/laatste\" class=\"zwart\">&rsaquo;</a></b>";
         }
         else
         {
            $forum_icon = forum_actief(0);
            $laatste_post = "Nooit";
         }

         // Moderator
         $moderators = get_moderators($f_info["forum_moderators"]);

         $tpl->assign(array("forum_icon"   => $forum_icon                              ,
                            "id"           => $f_info["forum_id"]                      ,
                            "titel"        => $f_info["forum_titel"]                   ,
                            "beschrijving" => $f_info["forum_beschrijving"]            ,
                            "topics"       => number_format($f_info["forum_topics"])   ,
                            "berichten"    => number_format($f_info["forum_berichten"]),
                            "laatste_post" => $laatste_post                            ,
                            "moderators"   => $moderators                              ,
                           ));
      }
      else
         $tpl->get_template("forums_geen_forum");
   }

   if($sql->num_rows($s_info))
      // Na de loop ook nog een categorie afsluiten..
      $tpl->get_template("forums_categorie_footer,tabel_footer");

   // Actieve gebruikers weergeven
   get_onlinelijst();

   // Footer
   $tpl->get_template("footer");

   include pad . "include/output.inc.php";

?>