<?php

include '../include/include.inc.php';

if(!$core["ingelogd"])
{
   bericht('Je kunt alleen gebruik maken van de topic tracker wanneer je bent ingelogd.');
}

if(!empty($data['t']) && is_numeric($data['t']))
{
   $s_i = $sql->query("SELECT 
                       COUNT(t.id) AS tid, tr.id, COUNT(tr2.id) AS aantal 
                       FROM forums_topics AS t, forums_forums AS f 
                       LEFT JOIN forums_tracker AS tr ON tr.tid = ".$data['t']." AND tr.uid = ".$core['lid_id']."
                       LEFT JOIN forums_tracker AS tr2 ON tr2.uid = ".$core['lid_id']."
                       WHERE t.id = ".$data['t']." AND f.id = t.fid AND (f.toegang <> 3 OR " . $core["status"] . " > 2)
                       GROUP BY t.id");

   $f_i = $sql->fetch($s_i);

   /*
    * De topic bestaat, maar is niet toegevoegd aan de tracker
    */

   if(!empty($f_i['tid']) && empty($f_i['id']))
   {
      if($f_i['aantal'] == 25)
      {
         bericht('Je hebt 25 topics toegevoegd aan je topic tracker, verwijder eerst een oude voordat je nieuwe topics toevoegd.');
      }

      $sql->query("INSERT INTO forums_tracker (id, tid, uid, laatst_bezocht)
                   VALUES (NULL, ".$data['t'].", ".$core['lid_id'].", UNIX_TIMESTAMP())");

      forward('De gekozen topic is succesvol toegevoegd aan je topic tracker!', url .'forums/topic/'.$data['t']);
   }

   /*
    * De topic bestaat en is toegevoegd aan de tracker
    */

   elseif(!empty($f_i['tid']) && !empty($f_i['id']))
   {
      $sql->query("DELETE FROM forums_tracker WHERE tid = ".$data['t']);

      forward('De gekozen topic is succesvol verwijderd uit je topic tracker', url .'forums/topic/'.$data['t']); 
   }

   /*
    * De topic bestaat niet
    */

   else
   {
      bericht('De topic die je wilt toevoegen aan de topic tracker bestaat niet, is niet toegevoegd aan jouw topic tracker of staat in een forum waar jij geen toegang tot hebt.');
   }
}
else
{
   $tpl->get_template('header,tabel_header,forums_tracker_header');
   
   include pad .'include/forums_dropdown.inc.php';

   $s_tracker = $sql->query("SELECT tr.*, t.*, l.status, l.gebruikersnaam, f.titel AS forum_titel
                             FROM forums_tracker AS tr, leden AS l, forums_forums AS f, forums_topics AS t
                             WHERE tr.uid = ".$core['lid_id']." AND t.id = tr.tid AND l.id = t.auteur AND f.id = t.fid
                             ORDER BY t.laatste_post DESC");

   if(!$sql->num_rows($s_tracker))
   {
      $tpl->get_template('forums_tracker_geen');
   }
   else
   {
      while($f_t = $sql->fetch($s_tracker))
      {
         $tpl->get_template('forums_tracker_topic');

         $titel = substr($f_t["titel"], 0, 60);

         if($titel != $f_t["titel"])
            $titel .= "...";
         
         if($f_t['laatste_post'] > $f_t['laatst_bezocht'])
         {
            $plaatje = 'topic_actief';
            $alt = 'Er zijn nieuwe berichten geplaatst in deze topic sinds jou laatste bezoek.';
         }
         else
         {
            $plaatje = 'topic';
            $alt = 'Er zijn geen nieuwe berichten geplaatst in deze topic sinds jou laatste bezoek.';
         }

         // datum + backward compability
         if(empty($f_t["laatste_auteur"]))
           $laatste_post = "op " . date_format($f_t["laatste_post"]) . " om " . date("H:i", $f_t["laatste_post"]);
         else
         {
            list($gebruikersnaam, $id) = explode(",", $f_t["laatste_auteur"]);
            $laatste_post = "op " . date("d-m-Y", $f_t["laatste_post"]) . " om " . date("H:i", $f_t["laatste_post"]) . " door <a href=\"" . url . "leden/profiel/" . $id . "\">" . $gebruikersnaam . "</a>";
         }
   
         // pagina verdeling                           
         if(($f_t["reacties"] + 1) > 20)
         {
            $paginas = ceil(($f_t["reacties"] + 1) / 20);
               
            $pg_select = array();
            for($i = 1; $i <= $paginas; $i++)
               $pg_select[] .= "<a href=\"" . url . "forums/topic/" . $f_t["id"] . "/" . $i . "\" class=\"zwart\">" . $i . "</a>";

            $paginas = "<small>(<img src=\"" . url . "images/forums/meer_paginas.gif\"> ";
            $paginas .= implode(" ", $pg_select);
            $paginas .= ")</small>";
         }
         else
            $paginas = "";

         $tpl->assign(array("titel"            => $titel                                        ,
                            "tid"              => $f_t["id"]                                    ,
                            "titel_alt"        => $f_t["titel"] . " (" . $f_t["forum_titel"] . ")",
                            "auteur_id"        => $f_t["auteur"]                                ,
                            "auteur"           => kleur($f_t["gebruikersnaam"], $f_t["status"]) ,
                            "reacties"         => $f_t["reacties"]                              ,
                            "laatste_post"     => $laatste_post                                 ,     
                            "plaatje"          => $plaatje                                      ,
                            "paginas"          => $paginas                                      ,
                            "alt"              => $alt                                          ,
                           ));  
      }
   }

   $tpl->assign(array('tabel_header.titel'           => 'Topic tracker',
                      'header.titel'                 => 'Topic tracker',
                     ));

   $tpl->get_template('forums_tracker_footer,tabel_footer,footer');

   $tpl->assign('forums_tracker_footer.select', $select);
}

include pad . 'include/output.inc.php';

?>