<?php

   class bbparser
   {
      var $code_cache;
      var $ignore_cache;
      var $crypt;
      
      function bbparser()
      {
         $this->code_cache = array();
         $this->ignore_cache = array();
         $this->crypt = array();
      }

      function highlight($code)
      {
         $this->hash[md5($code)] = $code;

         $code = ltrim(rtrim($code));
         $code = @highlight_string($code, true);

         return $code;
      }

      function __process_hash()
      {
         if(!empty($this->hash))
         {
            foreach($this->hash as $hash => $code)
            {
               if(!isset($_SESSION[$hash]))
               {
                  $_SESSION[$hash] = $code;
               }
            }
         }
      }

      function replace_code_tags($bericht, $deel)
      {
         if($deel == 0)
         {
            if(preg_match_all("!\[ignore\](.+)\[\/ignore\]!Usi", $bericht, $this->ignore_cache))
            {
               for($i = 0; $i < count($this->ignore_cache[0]); $i++)
               {
                  $this->crypt['ignore'][$i] = crypt($i);
                  $bericht = str_replace($this->ignore_cache[0][$i], '##'.$this->crypt['ignore'][$i].'##', $bericht);
               }
            }

            if(preg_match_all("!\[code\](.+)\[\/code\]!Usi", $bericht, $this->code_cache))
            {
               for($i = 0; $i < count($this->code_cache[0]); $i++)
               {
                  $this->crypt['code'][$i] = crypt($i);
                  $bericht = str_replace($this->code_cache[0][$i], '##'.$this->crypt['code'][$i].'##', $bericht);
               }
            }
         }

         
         if($deel == 1)
         {
            if($this->ignore_cache)
            {
               for($i = 0; $i < count($this->ignore_cache[1]); $i++)
               {
                  $bericht = str_replace('##'.$this->crypt['ignore'][$i].'##', nl2br(htmlspecialchars($this->ignore_cache[1][$i])), $bericht);
               }
            }

            if($this->code_cache)
            {
               for($i = 0; $i < count($this->code_cache[1]); $i++)
               {
                  $regels = count(explode("\n", ltrim(rtrim($this->code_cache[1][$i]))));
                  $regel  = "";

                  for($x = 1; $x <= $regels; $x++)
                  {
                     $regel .= $x . "<br>";
                  }

                  $replace = '<div style="padding-top: 5px"><table width="95%" cellpadding=3 cellspacing=0 border=0 style="border: solid #999999; border-width: 1px" align="center">
                   <tr>
                    <td width="100%" bgcolor="#f7f7f4">
                     <table width="100%" cellpadding=0 cellspacing=0 border=0>
                      <tr>
                       <td width="80%">
                        <code><b>Code:</b></code>
                       </td>
                       <td width="20%" align="right">
                        <a href="' . url . 'code?mode=1&amp;hash=' . md5($this->code_cache[1][$i]) . '" target="_blank"><img src="' .url . 'images/code_volledig.gif" width=9 height=12 alt="Geef deze code (volledig) in een popup venster weer" border=0></a> <a href="' . url . 'code?mode=2&amp;hash=' . md5($this->code_cache[1][$i]) . '" target="_blank"><img src="' .url . 'images/code_textarea.gif" height=12 width=11 alt="Geef deze code in een tekstveld weer" border=0>
                       </td>
                      </tr>
                     </table>
                    </td>
                   </tr>
                  </table><br>
                  <table width="95%" cellpadding=2 cellspacing=0 border=0 style="border: solid #999999; border-width: 1px; table-layout: fixed" align="center">
                   <tr>
                    <td width=26 nowrap bgcolor="#f7f7f4" valign="top">
                     <code>' .$regel. '</code>
                    </td>
                    <td width="100%" nowrap bgcolor="#ffffff" valign="top">
                    ' .$this->highlight($this->code_cache[1][$i]). '
                    </td>
                   </tr>
                  </table></div>';
                  
                  
                  $bericht = str_replace('##'.$this->crypt['code'][$i].'##', $replace, $bericht);
               }
            }

            unset($this->crypt);
            $this->crypt = array();
         }

         return $bericht;
      }

      function get_smilies($modus)
      {
         $smilie_replace_find = array(":o"      ,
                                      ":O"      ,
                                      ":-o"     ,
                                      ":-O"     ,
                                      ";)"      ,
                                      ";-)"     ,
                                      ":-)"     ,
                                      ":)"      ,
                                      ":p"      ,
                                      ":-p"     ,
                                      ":P"      ,
                                      ":p"      ,
                                      "(H)"     ,
                                      "(h)"     ,
                                      ":@"      ,
                                      ":-@"     ,
                                      "(6)"     ,
                                      ":D"      ,
                                      ":d"      ,
                                      ":-d"     ,
                                      ":-D"     ,
                                      ":'("     ,
                                      ":("      ,
                                      ":-("     ,
                                      ":$"      ,
                                      ":-$"     ,
                                      ":s"      ,
                                      ":-s"     ,
                                      ":S"      ,
                                      ":-S"     ,
                                      ":-|"     ,
                                      ":|"      ,
                                      "(-)"    ,
                                      ":l"      ,
                                      ":L"      ,
                                      ":e"      ,
                                      ":E"      ,
                                      ":!"      ,
                                      "(i)"     ,
                                      "(I)"     ,
                                      ":?"     ,
                                      "8-)"     ,
                                      "(y)"     ,
                                      "(n)"     ,
                                     );

         $smilie_replace_replace = array("<img src=\"".url."images/smilies/icon_surprised.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_surprised.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_surprised.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_surprised.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_wink.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_wink.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_smile.gif\" border=0>"      ,
                                         "<img src=\"".url."images/smilies/icon_smile.gif\" border=0>"      ,
                                         "<img src=\"".url."images/smilies/icon_razz.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_razz.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_razz.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_razz.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_cool.gif\" border=0>" ,
                                         "<img src=\"".url."images/smilies/icon_cool.gif\" border=0>" ,
                                         "<img src=\"".url."images/smilies/icon_mad.gif\" border=0>"      ,
                                         "<img src=\"".url."images/smilies/icon_mad.gif\" border=0>"      ,
                                         "<img src=\"".url."images/smilies/icon_evil.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_biggrin.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_biggrin.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_biggrin.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_biggrin.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_cry.gif\" border=0>"    ,
                                         "<img src=\"".url."images/smilies/icon_sad.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_sad.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_redface.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_redface.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_confused.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_confused.gif\" border=0>"   ,
                                         "<img src=\"".url."images/smilies/icon_confused.gif\" border=0>"   ,   
                                         "<img src=\"".url."images/smilies/icon_confused.gif\" border=0>"   ,  
                                         "<img src=\"".url."images/smilies/icon_neutral.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_neutral.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_arrow.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_lol.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_lol.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_eek.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_eek.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_exclaim.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_idea.gif\" border=0>"  ,
                                         "<img src=\"".url."images/smilies/icon_idea.gif\" border=0>"  ,            
                                         "<img src=\"".url."images/smilies/icon_question.gif\" border=0>"  ,        
                                         "<img src=\"".url."images/smilies/icon_rolleyes.gif\" border=0>"  ,  
                                         "<img src=\"".url."images/smilies/icon_yes.gif\" border=0>"  ,        
                                         "<img src=\"".url."images/smilies/icon_no.gif\" border=0>"  ,  
                                        );

         if($modus == 1)
            return $smilie_replace_find;
         elseif($modus == 2)
            return $smilie_replace_replace;

         return $smilies;
      }

      function replace_smilies($bericht)
      {
         return $bericht = str_replace($this->get_smilies(1), $this->get_smilies(2), $bericht);
      }

      function preparse($bericht)
      {
         global $core;
         
         $bericht = trim($bericht);
         $bericht = preg_replace("!(^|[ \n\r\t])(((ftp://)|(http://)|(https://))(([a-z0-9_-]+)(:([a-z0-9_\-]+([a-z0-9_\-]+\@)?))?\@)?(www\.)?([a-z0-9_-]|\.)+(\.[a-z]{2,4})(\:[0-9]+)?(/[^/: \n\r]*)*)!i", " [url=\\2]\\2[/url]", $bericht);
         $bericht = preg_replace("!\[img\](.+)\[/img\]!i", "[img=\\1]", $bericht);
         $bericht = preg_replace("!/me (.+)(\n)!i", "[ME=".$core["lidnaam"]."]\\1[/ME]", $bericht);

         return $bericht;
      }

      function replace_nested($tags)
      {
         $replace_find = array("!@#@#@#@#@##(.+)##@#@#@#!Usi"  ,
                               "!\[quote\](.+)\[\/quote\]!Usi",
                              );

         $replace_replace = array("[code]" ,
                                  "[quote]",
                                 );

         return $tags = preg_replace($replace_find, $replace_replace, $tags);         
      }

      function replace_advanced_tags($bericht)
      {
         if(preg_match_all("!\[quote\](.+)\[\/quote\]!Usi", $bericht, $matches))
         {
            for($i = 0; $i < count($matches[1]); $i++)
            {
               $matches[1][$i] = $this->replace_nested(ltrim(rtrim($matches[1][$i])));

               $replace = "<div style=\"padding-bottom: 5px\"><table width=\"98%\" align=\"center\" border=0 cellpadding=3 cellspacing=0>
                            <tr>
                             <td width=\"100%\">
                              <small>Quote:</small>
                             </td>
                            </tr>
                            <tr>
                             <td width=\"100%\" style=\"border: #999999 1px solid\" bgcolor=#f8f8f8>
                              ".ltrim(rtrim($matches[1][$i]))."
                             </td>
                            </tr>
                           </table></div>";

               $bericht = str_replace($matches[0][$i], $replace, $bericht);
            }
         }
         
         $adv_find = array("!\[li\](.+)\[\/li\]!Ui"                              ,
                           "!\[me=([a-zA-Z0-9%\./\:\-_~\?=\+]+)\](.+)\[\/me\]!Ui",
                          );

         $adv_replace = array("<li>\\1</li>"                             ,
                              "<font color=\"red\">* \\1 \\2</font>"     ,
                             );

         $bericht = preg_replace($adv_find, $adv_replace, $bericht);

         return $bericht;
      }

      function replace_url($bericht)
      {
         $url_find = array("!\[url=(.+)\](.+)\[\/url\]!Usi"                      ,
                           "!\[url=(.+)\]!Usi"                                   ,
                           "!\[url\](.+)\[\/url\]!Usi"                           ,
                          );

         $url_replace = array("<a href=\"\\1\" target=\"_blank\">\\2</a>",
                              "<a href=\"\\1\" target=\"_blank\">\\1</a>",
                              "<a href=\"\\1\" target=\"_blank\">\\1</a>",
                             );

         $bericht = preg_replace($url_find, $url_replace, $bericht);

         return $bericht;
      }

      function replace_img($bericht)
      {
         if(preg_match_all("!\[img=(.+)\]!Usi", $bericht, $matches))
         {
            for($i = 0; $i < count($matches[1]); $i++)
            {
					if (substr(trim($matches[1][$i]), 0, 10) == "javascript")
						$plaatje = "[Ongeldig plaatje]";
					else
	               $plaatje = "<img src=\"".$matches[1][$i]."\" id=\"topic\" onclick=\"image_fullscreen(this);\">";
               
               ## Eindelijk replacen
               $bericht = str_replace($matches[0][$i], $plaatje, $bericht);
            }
         }

         return $bericht;
      }

      function make_img_link($bericht)
      {
         if(preg_match_all("!\[img=(.+)\]!Usi", $bericht, $matches))
         {
            for($i = 0; $i < count($matches[1]); $i++)
            {
		         $size = @getimagesize($matches[1][$i]);
               
               if(!$size)
                  $bericht = str_replace($matches[0][$i], "[img] ".basename($matches[1][$i])." is ongeldig!", $bericht);
               else
                  $bericht = str_replace($matches[0][$i], "<a href=\"".$matches[1][$i]."\" target=\"_blank\">Plaatje (".basename($matches[1][$i]).")</a>", $bericht);
            }
         }

         return $bericht;
      }

      function parsen($bericht, $smilies = true, $html = false, $br = true, $advanced = true, $images = true, $url = true)
      {
         $start = getmicrotime();
         if($advanced)
            $bericht = $this->replace_code_tags($bericht, 0);

         if(!$html)
         {
		 $search = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
                 "'<[\/\!]*?[^<>]*?>'si",          // Strip out HTML tags
                 "'&(quot|#34);'i",                // Replace HTML entities
                 "'&(amp|#38);'i",
                 "'&(lt|#60);'i",
                 "'&(gt|#62);'i",
                 "'&(nbsp|#160);'i",
                 "'&(iexcl|#161);'i",
                 "'&(cent|#162);'i",
                 "'&(pound|#163);'i",
                 "'&(copy|#169);'i"); 

$replace = array ("",
                 "",
                 "\"",
                 "&",
                 "<",
                 ">",
                 " ",
                 chr(161),
                 chr(162),
                 chr(163),
                 chr(169));

$bericht = preg_replace($search, $replace, $bericht);

    
         }

         if($br)
            $bericht = nl2br($bericht);

        if($advanced)
           $bericht = $this->replace_advanced_tags($bericht);

        if($url)
           $bericht = $this->replace_url($bericht);

        if($images && $advanced)
           $bericht = $this->replace_img($bericht);
        elseif(!$images && $advanced)
           $bericht = $this->make_img_link($bericht);           

         if($smilies)
            $bericht = $this->replace_smilies($bericht);

         $std_replace_find = array("!\[b\](.+)\[\/b\]!Usi"                                                         ,
                                   "!\[i\](.+)\[\/i\]!Usi"                                                         ,
                                   "!\[u\](.+)\[\/u\]!Usi"                                                         ,
                                   "!\[s\](.+)\[\/s\]!Usi"                                                         ,
								   "!\[off\](.+)\[\/off\]!Usi"                                                     ,
								   "!\[offtopic\](.+)\[\/offtopic\]!Usi"                                           ,
								   "!\[edit\](.+)\[\/edit\]!Usi"                                           ,
								   "!\[sub\](.+)\[\/sub\]!Usi"                                           ,
                                   "!\[kleur=([a-zA-Z0-9#]+)\](.+)\[\/kleur\]!Usi",   
                                  );

         $std_replace_replace = array("<b>\\1</b>"                    ,
                                      "<i>\\1</i>"                    ,
                                      "<u>\\1</u>"                    ,
                                      "<s>\\1</s>"                    ,
									  "[offtopic]\\1[/offtopic]",
									  "<font color=\"#999999\" style=\"font-size:9px\"><i>Offtopic:</i><br />\\1</font>",
									  "<font color=\"#999999\" style=\"font-size:9px\"><i>Edit:</i><br />\\1</font>",
									  "<sub>\\1</sub>",
                                      "<font color=\"\\1\">\\2</font>",
                                     );

         $bericht = preg_replace($std_replace_find, $std_replace_replace, $bericht);

         ## Als laatste de [code] tags weer terugzetten
         if($advanced)
            $bericht = $this->replace_code_tags($bericht, 1);

         $end = getmicrotime() - $start;

         return $bericht;
      }
   }

?>
