<?php

   // Alle inkomende data verwerken...
   function input_data_parsen()
   {
      $data = array();

      if(is_array($_GET))
         while(list($var, $val) = each($_GET))
            if(is_array($_GET[$var]))
               while(list($var2, $val2) = each($_GET[$var]))
                  $data[$var][clean_key($var2)] = clean_value($val2);
            else
               $data[$var] = clean_value($val);

      if(is_array($_POST))
         while(list($var, $val) = each($_POST))
            if(is_array($_POST[$var]))
               while(list($var2, $val2) = each($_POST[$var]))
                  $data[$var][clean_key($var2)] = clean_value($val2);
            else
               $data[$var] = clean_value($val);

      return $data;
   }

   function clean_key($key)
   {
      if(empty($key))
         return;
      
      $key = preg_replace("!\.\.!", "", $key);
      $key = preg_replace("!\_\_(.+?)\_\_!", "", $key);
      $key = preg_replace("!^([\w\.\-\_]+)$!", "", $key);

      return $key;
   }

   function clean_value($val)
   {
      if(empty($val))
         return;

      $val = preg_replace("!<\!--!", "&#60;&#33;--", $val);
      $val = preg_replace("!-->!", "--&#62;", $val);
      $val = preg_replace("!<script!i", "&#60;script", $val);
      $val = preg_replace("!>!", "&gt;", $val);
      $val = preg_replace("!<!", "&lt;", $val);
    	$val = preg_replace("!\"!", "&quot;", $val);
      $val = preg_replace("!\|!", "&#124;", $val);
      $val = preg_replace("!\n!", "<br>", $val);
      $val = preg_replace("!\r!", "", $val);
      $val = preg_replace("!'!", "&#39;", $val);
      $val = stripslashes($val);
      $val = preg_replace("!\\\!", "&#092;", $val);
      $val = trim($val);

      return $val;
   }

   function fouten_verwerken($fouten)
   {
      global $tpl, $core, $sql, $bb;

      if(empty($fouten))
         return false;
      else
      {
         $tpl->get_template("site_header,site_tabel_header,foutpagina,tabel_footer,site_footer");

         $fout_html = "<ul>\n";
         for($i = 0; $i < count($fouten); $i++)
            $fout_html .= "<li>".$fouten[$i]."</li>\n";
         $fout_html .= "</ul>";

         $tpl->assign(array("site_header.titel"       => "Fout"                     ,
                            "site_tabel_header.titel" => "Er is een fout opgetreden",
                            "foutpagina.fouten"       => $fout_html                 ,
                           ));

         include pad . "include/output.inc.php";
         exit;
      }
   }

   function sleutel($tekens = false)
   {
      if(!$tekens)
         $tekens = 10;
       
      $sleutel = "";    
      $array = array ("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "v", "x", "y", "z", 1, 2, 3, 4, 5, 6, 7, 8, 9, 0);

      for ($i = 0; $i < $tekens; $i++)
         $sleutel .= $array[rand(0, 33)];
           
      return strtoupper($sleutel);
   }

   function forward($bericht, $url, $tijd = 2)
   {
      global $tpl, $core, $sql, $bb;
      
      $tpl->reset_tpl();

      if ($core["forward_zien"] == 0)
      {
         header("Location: " . $url);
      }
      
      $tpl->get_template("forward");
      
      $tpl->assign(array("forward.forward" => $url    ,
                         "forward.bericht" => $bericht,
                         "forward.tijd"    => $tijd   ,
                        ));

      include pad . "include/output.inc.php";
      exit;
   }

   function bericht($bericht, $titel = "Melding")
   {
      global $tpl, $core, $sql, $bb;

      $tpl->get_template("site_header,site_tabel_header,bericht,tabel_footer,site_footer");

      $tpl->assign(array("site_header.titel"       => $titel   ,
                         "site_tabel_header.titel" => $titel   ,
                         "bericht.bericht"         => $bericht ,
                        ));

      include pad . "include/output.inc.php";
      exit;
   }

   function haal_mail($titel, $extra_vars = "")
   {
      global $sql;
      
      $s_mail = $sql->query("SELECT email FROM mail WHERE titel = '".$titel."'");

      if($sql->num_rows($s_mail))
      {
         $mail = $sql->result($s_mail, 0);
         
         ## Dit zijn vaste replaces
         $mail = str_replace("{url}", url, $mail);
         $mail = str_replace("{sitenaam}", sitenaam, $mail);

         if(!empty($extra_vars))
         {
            foreach($extra_vars as $vervang => $door)
            {
               $mail = str_replace("{".$vervang."}", $door, $mail);
            }
         }

         $mail = preg_replace("!{(.+)}!Usi", "", $mail);

         return $mail;
      }
      else
         return false;
   }

   function email($van, $naar, $naar_naam, $titel, $bericht)
   {
      return mail($naar_naam." <" . $naar . ">", $titel, $bericht, "From: " . $van);

      //return mail ($naar_naam." <".$naar.">", $titel, $bericht, "From: ".$van) or die("HALT");
   }

   ## Pagina navigatie
   function pagina_navigatie($per_pagina, $aantal, $pagina, $inc_str = '')
   {
      global $data;

      $paginas = ceil($aantal / $per_pagina);
      
      if(!isset($pagina) || $data["pagina"] > $paginas || !is_numeric($data["pagina"]))
         $data["pagina"] = 1;
      if($data["pagina"] > $paginas || !is_numeric($data["pagina"]))
         $data["pagina"] = 1;

      $start = ($data["pagina"] - 1) * $per_pagina;
       
      $url = $_SERVER["SCRIPT_NAME"].$inc_str."/";

      if($data["pagina"] != 1)
      {
         if($data['pagina'] > 2)
         {
            $select[] = "<input type=\"button\" onclick=\"location='".$url."1'\" value=\"&lsaquo;&lsaquo;\"> ";
         }

         $select[] = "<input type=\"button\" onclick=\"location='".$url.($data["pagina"] - 1)."'\" value=\"&lsaquo;\"> ";
      }

      $select[] = "<select name=\"pagina\" onChange=\"snelkiezen(this)\">";
      for($i = 1; $i <= $paginas; $i++)
      {
         $selected = ($i == $data["pagina"]) ? "selected" : "";
         $select[] = "<option value=\"".$url.$i."\" ".$selected.">".$i."</option>";
      }
      
      if(count($select) == 1)
         $select[] = "<option value=\"".$url."1\">1</option>";

      $select[] = "</select>";

      $select = implode("", $select);
      
      if(($data["pagina"] + 1) <= $paginas)
         $select .= " <input type=\"button\" onclick=\"location='".$url.($data["pagina"] + 1)."'\" value=\"&rsaquo;\">";
      
      if($data["pagina"] < $paginas)
         $select .= " <input type=\"button\" onclick=\"location='".$url.$paginas."'\" value=\"&rsaquo;&rsaquo;\">";
      
      if($paginas == 1)
         $select = "<img src=\""  . url . "images/spacer.gif\" height=\"18\">";
      else
         $select = "<b>Pagina:</b> " . $select;
          
      $pn = array();
      $pn["select"]     = $select;
      $pn["start"]      = $start;
      $pn["per_pagina"] = $per_pagina;
      $pn["paginas"]    = $paginas;

      return $pn;
   }

   function kleur($gebruikersnaam, $status)
   {
      global $core;

      if($status == 1)
         $gebruikersnaam = "<font color=\"#ff0033\" title=\"Verbannen\">".$gebruikersnaam."</font>";
      elseif($status == 2 && in_array($gebruikersnaam, $core['elite']))
         $gebruikersnaam = "<font color=\"#000000\" title=\"Elite Lid\"><u>".$gebruikersnaam."</u></font>";
      elseif($status == 2 && empty($elite))
         $gebruikersnaam = "<font color=\"#000000\" title=\"Lid\">".$gebruikersnaam."</font>";
      elseif($status == 3)
         $gebruikersnaam = "<b><font color=\"#ff9933\" title=\"Moderator\">".$gebruikersnaam."</b></font>";
      elseif($status == 4)
         $gebruikersnaam = "<b><font color=\"#330099\" title=\"Super Moderator\">".$gebruikersnaam."</b></font>";
      elseif($status == 5)
         $gebruikersnaam = "<b><font color=\"#006600\" title=\"Beheerder\">".$gebruikersnaam."</b></font>";

      return $gebruikersnaam;
   }

   function get_status($status)
   {
      if($status == 1)
         return "Verbannen";
      elseif($status == 2)
         return "Lid";
      elseif($status == 3)
         return "Moderator";
      elseif($status == 4)
         return "Super Moderator";
      elseif($status == 5)
         return "Beheerder";
   }

   function email_spamvrij($email, $weergeven)
   {
      global $core;

      if(!$weergeven && $core["status"] < 4)
         return "Verborgen";
      else
      {
         $email = str_replace("@", " at  ", $email);
         $email = explode(".", $email);

         if(count($email) == 2)
            $email = implode(" dot ", $email);
         else
         {
            $aantal = count($email) - 2;
            $email[$aantal] .= " dot ";
            $email = implode(".", $email);
            $email = str_replace("dot .", "dot ", $email);                     
         }

         return $email;
      }
   }

   function ondertitel($ondertitel, $status)
   {
      if(empty($ondertitel))
         $ondertitel = get_status($status);
       
      return $ondertitel;    
   }

   function tekst_parsen($tekst, $status, $images = true)
   {
      global $bb, $core;

      if($status >= 4)
         $html = true;
      else
         $html = false;

      ## Rekening houden met de img en smilies optie van de gebruiker
      if($core["smilies"])
         $smilies = true;
      else
         $smilies = false;

      if($core["img"] && $images)
         $img = true;
      else
         $img = false;

      return $bb->parsen($tekst, $smilies, $html, true, true, $img);
   }

   ## Onderschrift parsen
   function onderschrift($onderschrift, $status)
   {
      global $bb, $core;

      if(!$core["ondrschrft"] || empty($onderschrift))
         return false;
      else
      {
         if($status >= 4)
            $html = true;
         else
            $html = false;

         ## Rekening houden met de smilies optie van de gebruiker
         if($core["smilies"])
            $smilies = true;
         else
            $smilies = false;

         return "<hr size=1 color=#999999 noshade width=450 align=\"left\">".$bb->parsen($onderschrift, $smilies, $html, true, false, false);
      }
   }

   ## Avatar vinden bij gebruikersnaam
   function get_avatar($id, $gebruikersnaam, $extensie, $force = 0)
   {
      global $core;

      if(!empty($extensie) && $core["avatars_zien"] || $force)
         return "<img src=\"".url."upload/avatars/".$id.".".$extensie."\" alt=\"Avatar van ".$gebruikersnaam."\"><br><br>";
      else
         return false;       
   }

   ## Functie om te kijken of het aantal gebruikte smilies niet te groot is
   function check_smilies($bericht)
   {
      global $bb;
      
      $bericht = preg_replace("!\[code\](.+)\[\/code\]!Usi", "", $bericht);

      $smilies = 0;
      $smilie_replace = $bb->get_smilies(1);

      for($i = 0; $i < count($smilie_replace); $i++) { 
         
         ## De hoeveelheid smilies tellen
         $smilies += substr_count($bericht, $smilie_replace[$i]); 
      }		

      if($smilies > 10)
         return false;
      else
         return true;
   }

   function replace_nesting($bericht) 
   {
      $search = array("!\[quote\](.+)\[\/quote\]!Usi",
                      "!\[code\](.+)\[\/code\]!Usi"  , 
                      "!\[img\](.+)\[\/img\]!Usi"    ,
                      "!\[img=(.+)\]!Usi"            ,
                     );
      
      $replace = array("[..]\n",
                       "[..]\n",
                       "[url=\\1][afbeelding][/url]\n",
                       "[url=\\1][afbeelding][/url]\n",
                      );
      $bericht = preg_replace($search, $replace, $bericht);

      return $bericht;
   }

   function bericht_actief($tijd)
   {
      if($tijd >= time() - 60*60*6)
         return "<img src=\"".url."images/bericht_actief.gif\" width=12 height=9 alt=\"Dit bericht is eerder dan 6 uur geleden geplaatst\">";
      else
         return "<img src=\"".url."images/bericht_niet_actief.gif\" width=12 height=9 alt=\"Dit bericht is 6 uur geleden of later geplaatst\">";
   }

   function forum_actief($tijd)
   {
      if($tijd >= time() - 60*60*6)
         return "<img src=\"" . url . "images/forums/forum_actief.jpg\" width=32 height=32 alt=\"In dit forum zijn in de laatste 6 uur posts gedaan.\">";
      else
         return "<img src=\"" . url . "images/forums/forum_niet_actief.jpg\" width=32 height=32 alt=\"In dit forum zijn geen nieuwe berichten geplaatst.\">";
   }

   function query_if($expressie, $wattrue, $watfalse)
   {
      if($expressie)
         return $wattrue;
      else
         return $watfalse;
   }

   function date_format($tijd, $jaar = false)
   {
      $dagen_array = array("zondag", "maandag", "dinsdag", "woensdag", "donderdag", "vrijdag", "zaterdag");
      $maand_array = array("januari", "februari", "maart", "april", "mei", "juni", "juli", "augustus", "september", "oktober", "november", "december");
      
      if(!$jaar)
         $datum = $dagen_array[date("w", $tijd)] . " " . date("j", $tijd) . " " . $maand_array[(date("n", $tijd) - 1)];
      else
         $datum = $dagen_array[date("w", $tijd)] . " " . date("j", $tijd) . " " . $maand_array[(date("n", $tijd) - 1)] . " " . date("Y", $tijd);

      return $datum;
   }

   function get_moderators($moderators)
   {
      if(empty($moderators))
         return "Geen";
      else
      {
         $moderators = explode(",", $moderators);
         
         $return = "";
         for($i = 0; $i < count($moderators); $i++)
         {
            list($gebruikersnaam, $id) = explode(":", $moderators[$i]);
            $return .= ", <a href=\" " . url . "leden/profiel/" . $id . "\" class=\"zwart\">" . $gebruikersnaam . "</a>";
         }
         return $return = substr($return, 2);
      }
   }

   function get_onlinelijst($style = 'tabel_header')
   {
      global $core, $tpl, $sql, $bb;

      $sql->query("DELETE FROM online WHERE tijd <= ".time()." - 60*5");
      $s_online = $sql->query("SELECT
                              o.gebruiker, o.onlinelijst, o.ip,
                              l.status, l.gebruikersnaam, l.geboortedatum
                              FROM
                              online AS o
                              LEFT JOIN leden AS l ON l.id = o.gebruiker
                              ORDER BY
                              l.gebruikersnaam ASC");
     
      $gasten  = 0;
      $anoniem = 0;
      $leden   = 0;

      $online_leden = "";

      while($f_o = $sql->fetch($s_online))
      {
         if(empty($f_o["gebruiker"]))
            $gasten++;
         elseif(!$f_o["onlinelijst"] && $core["status"] <= 3)
            $anoniem++;
         else
            $leden++;

         if(!empty($f_o["geboortedatum"]))
            $f_o["geboortedatum"] = explode("-", $f_o["geboortedatum"]);

         if(!empty($f_o["geboortedatum"]) && date("j-n") == $f_o["geboortedatum"][0]."-".$f_o["geboortedatum"][1])
            $leeftijd = " <font color=\"red\">(" .( date("Y") - $f_o["geboortedatum"][2] ). ")</font>";
         else
            $leeftijd = "";

         if($f_o["gebruiker"] && ($f_o["onlinelijst"] || $core["status"] > 3))
            $online_leden .= ", <a href=\"" . url . "leden/profiel/" . $f_o["gebruiker"] . "\">" . kleur($f_o["gebruikersnaam"], $f_o["status"]) . "</a>" . $leeftijd;
      }

      $online_leden = substr($online_leden, 2);

      $totaal = $gasten + $anoniem + $leden;

      if($gasten == 1)
         $gasten = "<b>1</b> gast";
      else
         $gasten = "<b>" . $gasten . "</b> gasten";

      if($anoniem == 1)
         $anoniem = "<b>1</b> anoniem lid";
      else
         $anoniem = "<b>" . $anoniem . "</b> anonieme leden";

      if(empty($online_leden))
         $online_leden = "Geen leden";

      if($totaal == 1)
         $totaal = "is er in totaal <b>1</b> bezoeker";
      else
         $totaal = "zijn er in totaal <b>". $totaal . "</b> bezoekers";

      $onlinelijst = $online_leden . ", " . $gasten . " en " . $anoniem . "<br>\nOp dit moment " . $totaal . " actief op " . sitenaam . "!";
         
      // De output
      $tpl->get_template($style);
      $tpl->assign("titel", "Actieve gebruikers");

      $tpl->get_template("onlinelijst");
      $tpl->assign("onlinelijst", $onlinelijst);

      $tpl->get_template("tabel_footer");
   }

   function is_moderator($moderators, $status = 0, $id = 0)
   {
      global $core;

      if(empty($status) || empty($id))
      {
         $status = $core["status"];
         $id     = $core["lid_id"];
      }

      if($status > 3)
         return true;
      elseif(empty($moderators))
         return false;
      else
      {
         $moderators = explode(",", $moderators);
            
         for($i = 0; $i < count($moderators); $i++)
         {
            list($gebruikersnaam, $mod_id) = explode(":", $moderators[$i]);
            if($mod_id == $id)
            {
               $true = 1;
               return true;
               break;
            }
         }

         if(empty($true))
            return false;
      }
   }
  
   function genereer_poll($pid, $gesloten, $tid, $moderators, $auteur)
   {
      global $sql, $tpl, $core, $data, $bb, $_aGET;

      $s_poll = $sql->query("SELECT id, titel, stemmen, opties, gestemd, gesloten FROM forums_polls WHERE id = " . $pid);
      $f_poll = $sql->fetch($s_poll);

      // kijken of deze gebruiker heeft gestemd
      if(!empty($f_poll["gestemd"]))
      {
         $a_gestemd = explode(",", $f_poll["gestemd"]);

         if(in_array($core["lid_id"], $a_gestemd))
            $gestemd = 1;
      }   
 
      preg_match_all("!\"(.+)\":\"(.+)\"!U", $f_poll["opties"], $f_poll["opties"]);

      if(!empty($_POST["stemmen"]))
      {
         $tpl->reset_tpl();
         
         if(empty($_POST['optie']))
            bericht('Je moet wel een optie kiezen uit de poll voordat je stemt!');

         if(!empty($gestemd))
            bericht("Je hebt al gestemd in deze poll, nog een keer stemmen is niet nodig.");
         else
         {
            if(!in_array($data["optie"], $f_poll["opties"][1]) || $f_poll["gesloten"] == 1)
               bericht("Er klopt iets niet aan dit formulier, of de poll is gesloten!");
            else
            {
               $opties = '';
               for($i = 0; $i < count($f_poll["opties"][0]); $i++)
               {
                  $f_poll["opties"][2][$i] = $f_poll["opties"][1][$i] == $data["optie"] ? $f_poll["opties"][2][$i] = $f_poll["opties"][2][$i] + 1 : $f_poll["opties"][2][$i];

                  $opties .= "\"" . $f_poll["opties"][1][$i] . "\":\"" . $f_poll["opties"][2][$i] . "\",";
               }
               $opties = substr($opties, 0, -1);
               
               if(empty($f_poll["gestemd"]))
                  $gestemd = $core["lid_id"];
               else
                  $gestemd = $f_poll["gestemd"] . ",".$core["lid_id"];

               $sql->query("UPDATE forums_polls SET stemmen = stemmen + 1, gestemd = '" . $gestemd . "', opties = '" . $opties . "' WHERE id = " . $pid);               

               forward("Je hebt je stem succesvol uitgebracht in deze poll.", url. "forums/topic/" . $tid);

               include pad . "include/output.inc.php";
               exit;
            }
         }
      }

      $img_opties = "";

      if(($auteur == $core["lid_id"] && $gesloten == 0 && $f_poll["gesloten"] == 0) || is_moderator($moderators))
         $img_opties .= "<a href=\"" . url . "forums/poll_bewerken?pid=" . $f_poll["id"] . "\"><img src=\"" . url  . "images/forums/bewerken.gif\" alt=\"Poll Bewerken\" border=0></a> "; 

      if(is_moderator($moderators))
         $img_opties .= "<a href=\"" . url . "forums/verwijderen?pid=" . $f_poll["id"] . "\" onclick=\"return bevestig(this, 'Weet je zeker dat je deze poll wilt verwijderen?')\"><img src=\"" . url . "images/forums/verwijder.gif\" alt=\"Verwijderen\" border=0></a> ";

      if(is_moderator($moderators))
         $img_opties .= "<a href=\"" . url . "forums/sluiten?pid=" . $f_poll["id"] . "\" onclick=\"return bevestig(this, 'Weet je zeker dat je deze poll wilt sluiten / heropenen?')\"><img src=\"" . url . "images/forums/sluiten.gif\" alt=\"Topic sluiten / openen\" border=0></a>";

      $tpl->get_template("tabel_header,forums_poll_stdheader");
      
      $tpl->assign(array("tabel_header.titel" => "Forum Poll"                       ,
                         "titel"              => $f_poll["titel"]                   ,
                         "img_opties"         => $img_opties                        ,                           
                        ));

      if($f_poll["gesloten"] == 1 || $gesloten == 1)
         $waarom = "Deze poll is gesloten, dus je kunt niet langer stemmen.";
      elseif(!$core["ingelogd"])
         $waarom = "Je bent niet ingelogd, je kunt alleen stemmen als je bent ingelogd.";
      elseif(!empty($gestemd))
         $waarom = "Je hebt al gestemd, je kunt maar &eacute;&eacute;n keer stemmen.";
      elseif(!empty($_aGET[1]) && $_aGET[1] == 'resultaten')
         $waarom = "Je bekijkt de resultaten, om te stemmen kun je <a href=\"" . url . "forums/topic/" . $tid . "\">hier</a> klikken.";
      
      if($f_poll["gesloten"] == 1 || $gesloten == 1 || !$core["ingelogd"] || !empty($gestemd) || (!empty($_aGET[1]) && $_aGET[1] == 'resultaten'))
      {
         $tpl->get_template("forums_poll_stats_header");

         for($i = 0; $i < count($f_poll["opties"][0]); $i++)
         {
            // uitrekenen hoeveel procent van totaal
            if($f_poll["opties"][2][$i] == 0)
               $procent = 0;
            else
               $procent = round(($f_poll["opties"][2][$i] / $f_poll["stemmen"] * 100), 0);

            $tpl->get_template("forums_poll_stats");

            $statistieken = "<img src=\"" . url . "images/forums/poll_links.gif\" width=2 height=8>";
            $statistieken .= "<img src=\"" . url . "images/forums/poll.gif\" width=" . ($procent * 2.5) . " height=8>";
            $statistieken .= "<img src=\"" . url . "images/forums/poll_rechts.gif\" width=2 height=8> (" . $procent . "%)";

            $tpl->assign(array("optie"        => $f_poll["opties"][1][$i],
                               "stemmen"      => $f_poll["opties"][2][$i],
                               "statistieken" => $statistieken           ,
                              ));
         }

         $tpl->get_template("forums_poll_stats_footer");
         $tpl->assign(array("waarom" => $waarom           ,
                            "totaal" => $f_poll["stemmen"],
                           ));
      }
      else
      {
         $tpl->get_template("forums_poll_stem_header");
         $tpl->assign("tid", $tid);

         for($i = 0; $i < count($f_poll["opties"][0]); $i++)
         {
            $tpl->get_template("forums_poll_stem_optie");
            $tpl->assign("optie", $f_poll["opties"][1][$i]);
         }

         $tpl->get_template("forums_poll_stem_footer");
         $tpl->assign("tid", $tid);
      }

      $tpl->get_template("tabel_footer");
   }

   function admin_log($actie)
   {
      global $core, $sql;

      $sql->query("INSERT INTO admin_log (id, auteur, actie, datum) VALUES(NULL, ".$core["lid_id"].", '".$actie."', '".time()."')");
   }

   $s_o = $sql->query("SELECT gebruiker FROM online WHERE gebruiker != 0");
   $current_online = array();

   while($f_o = $sql->fetch($s_o))
      $current_online[] = $f_o['gebruiker'];

   function get_online($id)
   {
      global $current_online;
      
      if(!in_array($id, $current_online))
         return "<img src=\"" . url . "images/offline.png\" alt=\"Deze gebruiker is op dit moment offline\">";
      else
         return "<img src=\"" . url . "images/online.png\" alt=\"Deze gebruiker is momenteel online\">";
   }

   function get_rank($posts)
   {
      if($posts <= 25)
         return "rank0";
      elseif($posts > 25 && $posts <= 100)
         return "rank1";
      elseif($posts > 100 && $posts <= 250)
         return "rank2";
      elseif($posts > 250 && $posts <= 400)
         return "rank3";
      elseif($posts > 400 && $posts <= 600)
         return "rank4";
      elseif($posts > 600 && $posts <= 800)
         return "rank5";
      elseif($posts > 800)
         return "rank6";
   }



   function get_readers($tid, $style)
   {
      global $sql, $core, $tpl;

      $s_online = $sql->query("SELECT
                              o.gebruiker, o.onlinelijst, o.ip,
                              l.status, l.gebruikersnaam, l.geboortedatum, o.pagina
                              FROM online AS o
                              LEFT JOIN leden AS l ON l.id = o.gebruiker
                              WHERE o.pagina REGEXP('topic/" . $tid . "')
                              ORDER BY l.gebruikersnaam ASC");
     
      $gasten  = 0;
      $anoniem = 0;
      $leden   = 0;

      $online_leden = "";

      while($f_o = $sql->fetch($s_online))
      {
         if(empty($f_o["gebruiker"]))
            $gasten++;
         elseif(!$f_o["onlinelijst"] && $core["status"] <= 3)
            $anoniem++;
         else
            $leden++;

         if(!empty($f_o["geboortedatum"]))
            $f_o["geboortedatum"] = explode("-", $f_o["geboortedatum"]);

         if(!empty($f_o["geboortedatum"]) && date("j-n") == $f_o["geboortedatum"][0]."-".$f_o["geboortedatum"][1])
            $leeftijd = " <font color=\"red\">(" .( date("Y") - $f_o["geboortedatum"][2] ). ")</font>";
         else
            $leeftijd = "";

         if($f_o["gebruiker"] && ($f_o["onlinelijst"] || $core["status"] > 3))
            $online_leden .= ", <a href=\"" . url . "leden/profiel/" . $f_o["gebruiker"] . "\">" . kleur($f_o["gebruikersnaam"], $f_o["status"]) . "</a>" . $leeftijd;
      }

      $online_leden = substr($online_leden, 2);

      $totaal = $gasten + $anoniem + $leden;

      if($gasten == 1)
         $gasten = "<b>1</b> gast";
      else
         $gasten = "<b>" . $gasten . "</b> gasten";

      if($anoniem == 1)
         $anoniem = "<b>1</b> anoniem lid";
      else
         $anoniem = "<b>" . $anoniem . "</b> anonieme leden";

      if(empty($online_leden))
         $online_leden = "Geen leden";

      $onlinelijst = "Op dit moment lezen " . $online_leden . ", " . $gasten . " en " . $anoniem . " deze topic.";
         
      // De output
      $tpl->get_template($style);
      $tpl->assign("titel", "Gebruikers in deze topic");

      $tpl->get_template("onlinelijst");
      $tpl->assign("onlinelijst", $onlinelijst);

      $tpl->get_template("tabel_footer");

   }
                             
?>
