<?php

   header("Cache-control: private");
  
   // Sessie
   session_start();

   // Error reporting
   error_reporting(E_ALL);

   // Magic quotes
   set_magic_quotes_runtime(0);
   
   // Tijdzone instellen
   putenv("TZ=Europe/Amsterdam");

   // Pad informatie opgeven
   define("url", "http://62.163.215.168/source/phpxp/");
   define("pad", "C:\Program Files\Apache Group\Apache2\htdocs\source\phpxp/");
   define("sitenaam", "PHPExperience.nl");


   // Alternatieve _GET var opbouwen
   if(!empty($_SERVER['PATH_INFO']))
   {
      $_aGET = substr($_SERVER['PATH_INFO'], 1);
      $_aGET = explode('/', $_aGET);
   }

   // Het echte IP van de gebruiker zoeken
   function haal_ip() 
   { 
      if (getenv("HTTP_CLIENT_IP") && strcasecmp(getenv("HTTP_CLIENT_IP"), "unknown")) 
      {
         $ip = getenv("HTTP_CLIENT_IP"); 
      }
      elseif (getenv("HTTP_X_FORWARDED_FOR") && strcasecmp(getenv("HTTP_X_FORWARDED_FOR"), "unknown")) 
      {
         $ip = getenv("HTTP_X_FORWARDED_FOR"); 
      }
      elseif (getenv("REMOTE_ADDR") && strcasecmp(getenv("REMOTE_ADDR"), "unknown")) 
      {
         $ip = getenv("REMOTE_ADDR"); 
      }
      elseif (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], "unknown")) 
      {
         $ip = $_SERVER['REMOTE_ADDR']; 
      }
      else 
      {
         $ip = "Onbekend"; 
      }

      // Het IP teruggeven 
      return $ip; 
   } 

   // Classes includen
   include pad . "include/template.class.php";
   include pad . "include/database.class.php";
   include pad . "include/bbparser.class.php";
   include pad . "include/leden.class.php";
   include pad . "include/rating.class.php";

   function getmicrotime() 
   { 
      $time = explode(" ", microtime()); 
         
      return $time[0] + $time[1]; 
   }

   // Classes initialiseren
   $tpl   = new template;
   $sql   = new database;
   $bb    = new bbparser;
   $leden = new leden;
   
   // Template engine
   $tpl->assign_global("url", url);
   $tpl->assign_global("pad", pad);
   $tpl->assign_global("sitenaam", sitenaam);
   $tpl->assign_global("php_self", $_SERVER["PHP_SELF"]);
   $tpl->assign_global("knop", "<img src=\"" . url . "images/layout/knop.gif\" width=15 height=15 alt=\"\">");

   $core                                  = array();
   $core["versie"]                        = "versie 1.3";
   $core["tijd"]                          = getmicrotime();
   $core["ingelogd"]                      = false;
   $core["lidnaam"]                       = "";
   $core["lid_id"]                        = 0;
   $core["email"]                         = "";
   $core["status"]                        = 0;
   $core["verbannen"]                     = 0;
   $core["posts"]                         = 0;
   $core["avatar"]                        = "";
   $core["avatars_zien"]                  = 1;
   $core["forward_zien"]                  = 1;
   $core["img"]                           = 1;
   $core["ondrschrft"]                    = 1;
   $core["smilies"]                       = 1;
   $core["offline"]                       = 0;
   $core["pbs"]                           = 0;
   $core["onlinelijst"]                   = 0;
   $core["t_laatste"]                     = 1;
   $core["menu"]["persoonlijk"]           = 0;
   $core["menu"]["actief"]                = 1;
   $core["menu"]["actief_aantal"]         = 10;
   $core["menu"]["linkpartners"]          = 1;
   $core['elite']                         = array();

   $leden->get_info($core);

   // Andere bestanden includen
   include pad . "include/functions.inc.php";
   include pad . "include/formulier.inc.php";

   $core["ip"] = haal_ip();

   // Alle input data verwerken
   $data = input_data_parsen();

   ## De categorien die zijn toegestaan even opgeven
   $core["allowed_cats"] = array();

   $tpl->assign_global("lidnaam", $core["lidnaam"]);
   $tpl->assign_global("lid_id", $core["lid_id"]);
   $tpl->assign_global("pbs", $core["pbs"]);

   // De 'Elite' ophalen

   $s_elite = $sql->query("SELECT gebruikersnaam FROM leden WHERE elite = 1");

   while($f_elite = $sql->fetch($s_elite))
      $core['elite'][] = $f_elite['gebruikersnaam'];

   if($core["status"] > 2 && empty($skip_counter))
   {
      $sql->query("DELETE FROM flood WHERE tijd <= ".time()." - 60*20");
      $sql->query("DELETE FROM leden WHERE actief = 0 AND tijd <= ".time()." - 60*60*48 AND verwijderen = 1");
      $sql->query("DELETE FROM uniek WHERE tijd <= " .mktime(0, 0, 0, date('m'), date('d'), date('Y')));
   }

   $huidige_pagina = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];

   // Onlinelijst bijhouden
   if($core["ingelogd"] && empty($skip_counter))
   {
      $s_online = $sql->query("SELECT COUNT(1) FROM online WHERE gebruiker = '" . $core["lid_id"] . "'");

      if(!$sql->result($s_online, 0))
         $sql->query("INSERT INTO online (id, gebruiker, ip, tijd, onlinelijst, pagina) VALUES ('NULL', '" . $core["lid_id"] . "', '', '" . time() . "', '" . $core["onlinelijst"] . "', '" . $huidige_pagina . "')");
      else
         $sql->query("UPDATE online SET tijd = '" . time() . "', onlinelijst = '" . $core["onlinelijst"] . "', pagina = '" . $huidige_pagina . "' WHERE gebruiker = '" . $core["lid_id"] . "'");
   }
   elseif(empty($skip_counter))
   {
      $s_online = $sql->query("SELECT COUNT(id) FROM online WHERE ip = '" . $core["ip"] . "'");

      if(!$sql->result($s_online, 0))
         $sql->query("INSERT INTO online (id, gebruiker, ip, tijd, pagina) VALUES ('NULL', '', '" . $core["ip"] . "', '" . time() . "', '" . $huidige_pagina . "')");
      else
         $sql->query("UPDATE online SET tijd = '" . time() . "', pagina = '" . $huidige_pagina . "' WHERE ip = '" . $core["ip"] . "'");
   }

   // Offline pagina
   if(!empty($core["offline"]))
      fatal_error(tekst_parsen($core["offline"], 5), sitenaam." offline", 0, 1);

   // Functie om belangrijke meldingen / fouten mee weer te geven
   function fatal_error($melding, $titel = "", $is_foutmelding = 1, $login_form = 0)
   {
      global $sql, $tpl, $core, $data, $leden;

      if(empty($titel))
         if($is_foutmelding = 1)
            $titel = "Foutmelding";
         else
            $titel = "Melding";

      include pad . "include/fout.inc.php";
      exit;
   }

   $datum = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

   // Bezoeker tellertjes
   $s_geg = $sql->query("SELECT ub.datum, un.ip
                         FROM bezoekers
                         LEFT JOIN bezoekers AS ub ON ub.datum = " .$datum. "
                         LEFT JOIN uniek AS un ON un.ip = '" .$core['ip']. "'");
   $f_geg = $sql->fetch($s_geg);

   if(empty($f_geg['datum']) && empty($skip_counter))
   {
      $sql->query("INSERT INTO bezoekers (id, datum, uniek, hits)
                   VALUES (NULL, " .$datum. ", 1, 1)");
      $sql->query("INSERT INTO uniek (ip, cat, tijd) VALUES ('" .$core['ip']. "', 3, UNIX_TIMESTAMP())");
   }
   
   if(empty($f_geg['ip']) && !empty($f_geg['datum']) && empty($skip_counter))
   {
      $sql->query("UPDATE bezoekers SET uniek = uniek + 1, hits = hits + 1 WHERE datum = " . $datum);
      $sql->query("INSERT INTO uniek (ip, cat, tijd) VALUES ('" .$core['ip']. "', 3, UNIX_TIMESTAMP())");
   }
   elseif(empty($skip_counter))
   {
      $sql->query("UPDATE bezoekers SET hits = hits + 1 WHERE datum = " .$datum);
   }

   include pad . "reacties/class.reactiesysteem.inc.php";

   

?>
