<?php

include "include/include.inc.php";

$info = array();

if(!empty($_POST['whois_check']))
{
   @header("Location: " . url . "whois/" . $_POST['domein']);
}

function whois_check($server, $ext, $domein, $uitgebreid = 0)
{
   if(!$uitgebreid && $ext == 'com')
      $server = 'whois.crsnic.net';

   if (($ns = @fsockopen($server, 43)) == false)
      $info = 'skipped';
   else
   {
      if(!$uitgebreid && $ext == 'nl')
         fputs($ns, "is " . $domein.".".$ext."\r\n");
      else
         fputs($ns, $domein.".".$ext."\r\n");

      $output = '';
      while(!feof($ns))
         $output .= fgets($ns, 128); 

      fclose($ns);

      $info = $output;
   }

   return $info;
}

function build_available($info, $err_str)
{
   if(eregi($err_str, $info))
      return 1;
   elseif($info == 'skipped')
      return 2;      
   else
      return 0;
}

$ext = array('com', 'net', 'org', 'nu', 'nl', 'be', 'de', 'co.uk', 'info', 'biz', 'tv');
$server = array('whois.networksolutions.com', 'whois.networksolutions.com', 'whois.publicinterestregistry.net', 'whois.nic.nu', 'whois.nic.nl', 'whois.dns.be', 'whois.nic.de', 'whois.nic.uk', 'whois.afilias.net', 'whois.nic.biz', 'whois.internic.net');
$nf_msg = array('No match for', 'No match for', 'NOT FOUND', 'NO MATCH for', 'is free', 'No such domain', 'free', 'No match', 'NOT FOUND', 'Not found', 'No match for');

if(!empty($_aGET[1]) && $_aGET[0] == 'info')
{
   $domein = explode('.', $_aGET[1]);
   $_aGET[1] = $domein[0];
   
   unset($domein[0]);
  
   $d_ext = implode('.', $domein);

   if(!ereg("^([a-z]|[A-Z]|[0-9]|-)+$", $_aGET[1]) || ereg("^-|-$", $_aGET[1]) || strlen($_aGET[1]) > 50)
   {
      bericht('Het domein begint met een streepje, bevat tekens die niet in een domeinnaam mogen voorkomen of is langer dan 50 tekens.');
   }
   elseif(!in_array($d_ext, $ext))
   {
      bericht('Je hebt een ongeldig domein opgegeven of dit wordt niet ondersteund door dit whois script.');
   }

   $id = array_keys($ext, $d_ext);

   $info = whois_check($server[$id[0]], $d_ext, $_aGET[1], 1);

   $tpl->get_template('site_header,site_tabel_header,whois_uitgebreid,tabel_footer,site_footer');

   $tpl->assign(array('site_tabel_header.titel' => 'Uitgebreide whois query voor ' . $_aGET[1].'.'.$d_ext,
                      'site_header.titel'       => 'Uitgebreide whois query'                             ,
                      'whois_uitgebreid.info'   => $info                                                 ,
                      'whois_uitgebreid.domein' => $_aGET[1] . '.' . $d_ext                              ,
                     ));
}
else
{
   if(empty($_aGET[0]) || !strlen($_aGET[0]))
   {
      bericht('Je hebt geen domeinnaam opgegeven, vul een domeinnaam in als je een whois check wilt doen.');
   }
   elseif(!ereg("^([a-z]|[A-Z]|[0-9]|-)+$", $_aGET[0]) || ereg("^-|-$", $_aGET[0]) || strlen($_aGET[0]) > 50)
   {
      bericht('Het domein begint met een streepje, bevat tekens die niet in een domeinnaam mogen voorkomen of is langer dan 50 tekens. Pas op, vul geen domeinextensie in!');
   }
   else
   {
      for($i = 0; $i < count($ext); $i++)
      {
         $info[$ext[$i]] = whois_check($server[$i], $ext[$i], $_aGET[0]);
         $av[$ext[$i]] = build_available($info[$ext[$i]], $nf_msg[$i]);
      }

      $tpl->get_template('site_header,site_tabel_header,whois_header');
      
      $tpl->assign(array('site_header.titel'       => 'Whois resultaten',
                         'site_tabel_header.titel' => 'Whois resultaten',
                        ));

      for($i = 0; $i < count($ext); $i++)
      {
         $bgcolor = $i % 2 == 1 ? '#f8f8f8' : '';

         $tpl->get_template('whois');

         if($av[$ext[$i]] == 0)
            $status = "<font color=\"red\">bezet</font>";
         elseif($av[$ext[$i]] == 1)
            $status = "<font color=\"green\">beschikbaar</font>";
         else
            $status = "de server gaf geen reactie";

         if($av[$ext[$i]] == 0)
            $watnu = '<a href="' . url . 'whois/info/' . $_aGET[0] . '.' . $ext[$i] . '">Meer informatie</a>';
         else
            $watnu = '';

         $tpl->assign(array('domein'  => $_aGET[0] . '.' . $ext[$i],
                            'status'  => $status                   ,
                            'bgcolor' => $bgcolor                  ,
                            'watnu'   => $watnu                    ,
                           ));
      }

      $tpl->get_template('whois_footer,tabel_footer,site_footer');
   }
}

include pad . "include/output.inc.php";

?>